searchNodes=[{"type":"module","title":"NextLS.DB","doc":"","ref":"NextLS.DB.html"},{"type":"function","title":"NextLS.DB.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"NextLS.DB.html#child_spec/1"},{"type":"function","title":"NextLS.DB.clean_references/2","doc":"","ref":"NextLS.DB.html#clean_references/2"},{"type":"function","title":"NextLS.DB.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"NextLS.DB.html#init/1"},{"type":"function","title":"NextLS.DB.insert_reference/2","doc":"","ref":"NextLS.DB.html#insert_reference/2"},{"type":"function","title":"NextLS.DB.insert_symbol/2","doc":"","ref":"NextLS.DB.html#insert_symbol/2"},{"type":"function","title":"NextLS.DB.query/3","doc":"","ref":"NextLS.DB.html#query/3"},{"type":"function","title":"NextLS.DB.start_link/1","doc":"","ref":"NextLS.DB.html#start_link/1"},{"type":"type","title":"NextLS.DB.query/0","doc":"","ref":"NextLS.DB.html#t:query/0"},{"type":"module","title":"NextLS.DB.Schema","doc":"The Sqlite3 database schema. First, you are probably asking yourself, why doesn't this use Ecto? Well, because I didn't want to. And also because I am attempting to restrict this project to as few dependencies as possible. The Ecto migration system is meant for highly durable data, that can't and shouldn't be lost, whereas the data here is more like a fast and efficient cache. Rather than coming up with convoluted data migration strategies, we follow the following algorithm. Create the schema table if needed. This includes a version column. If the max version selected from the schema table is equal to the current version, we noop and halt. Else, if the max version is less than the current one (compiled into this module) or nil we &quot;upgrade&quot; the database. Unless halting, we drop the non-meta tables, and then create them from scratch Return a value to signal to the caller that re-indexing is necessary.","ref":"NextLS.DB.Schema.html"},{"type":"function","title":"NextLS.DB.Schema.init/1","doc":"","ref":"NextLS.DB.Schema.html#init/1"},{"type":"extras","title":"Next LS","doc":"The language server for Elixir that just works. 😎 Still in heavy development, currently supporting the following features: Compiler Diagnostics Code Formatting Workspace Symbols Document Symbols Go To Definition Workspace Folders Find References Extensions Credo","ref":"readme.html"},{"type":"extras","title":"Next LS - Editor Support","doc":"Neovim: elixir-tools.nvim VSCode: elixir-tools.vscode Emacs Using eglot: ```elisp (require 'eglot) (add-to-list 'exec-path \"path/to/next-ls/bin/\") (with-eval-after-load 'eglot (add-to-list 'eglot-server-programs `((elixir-ts-mode heex-ts-mode elixir-mode) . (\"nextls\" \"--stdio=true\")))) (add-hook 'elixir-mode-hook 'eglot-ensure) (add-hook 'elixir-ts-mode-hook 'eglot-ensure) (add-hook 'heex-ts-mode-hook 'eglot-ensure) ``` Helix Add the following config to your `~/.config/helix/languages.toml`. ```toml [[language]] name = \"elixir\" scope = \"source.elixir\" language-server = { command = \"path/to/next-ls\", args = [\"--stdio=true\"] } ```","ref":"readme.html#editor-support"},{"type":"extras","title":"Next LS - Installation","doc":"The preferred way to use Next LS is through one of the supported editor extensions. If you need to install Next LS on it's own, you can download the appropriate executable from our GitHub Releases . These executables are created with Burrito and are completely standalone, except you'll still need Elixir and OTP installed in order for it to start a runtime for your application code.","ref":"readme.html#installation"},{"type":"extras","title":"Next LS - Development","doc":"If you are making changes to Next LS and want to test them locally you can run bin/start --port 9000 to start the language server (port 9000 is just an example, you can use any port that you want as long as it is not being used already). Then you can configure your editor to connect to Next LS using that port. elixir-tools.nvim { nextls = {enable = true, port = 9000} } Visual Studio Code { &quot;elixir-tools.nextls.adapter&quot;: &quot;tcp&quot;, &quot;elixir-tools.nextls.port&quot;: 9000 } Note Next LS creates an .elixir-tools hidden directory in your project, but it will be automatically ignored by git .","ref":"readme.html#development"},{"type":"extras","title":"Next LS - Troubleshooting","doc":"1. Is epmd running? Linux/Mac: pgrep -fl epmd If epmd is not running, you might need to start it or ensure it starts automatically with your system. You can do this by running epmd -daemon . 2. Ensure glibc version is at least 2.34 Linux: ldd --version This will show the glibc version at the top. Ensure it's 2.34 or higher. Mac: macOS doesn't use glibc ; it uses the Darwin C Library. Hence, this step is not applicable. Windows: Windows does not use glibc . If you're using a subsystem or tool that needs it, ensure it's updated. 3. Open Visual Studio Code from the terminal To ensure that elixir is in your PATH , open Visual Studio Code from the terminal using the command-line tools . 4. Does it work in TCP mode? All Platforms: Start the language server in TCP mode and connect to it with your editor, as described above. Both extensions install the Next LS executable to ~/.cache/elixir-tools/nextls/bin/nextls , so you can start the server with ~/.cache/elixir-tools/nextls/bin/nextls --port 9000 . 5. Firewall Interference Sometimes, the firewall can interfere with epmd and each Erlang node's ability to cluster. If you face connection issues, you might try turning off the firewall temporarily to see if it resolves the issue. This is usually a problem on macOS, as you should see a popup asking if beam and epmd can accept incoming connections (which you should click &quot;yes&quot;). In future version, we plan to sign and notarize the darwin binaries, which should avoid this popups and make this a non-issue.","ref":"readme.html#troubleshooting"}]